function grafo = MSTdivideetimperasort(X,cut,index)
%dati:

%un vettore X di n punti in Rm
%un indice cut
%un insieme di indici che identificano i nodi


%calcola uno spanning tree di X usando un'euristica di tipo divide et
%impera che a ogni chiamata ordina il vettore in base alla coordinata
%cut+1 mod m, divide lo spazio in due regioni che contengono n/2 nodi ciscuna, 
%calcola i due spanning tree dei nodi contenuti nelle singole regioni
%e li unisce in un unico spanning tree scegliendo un arco fra i sqrt(n)/m
% nodi di ogni regione pi vicini all'iperpiano che separa le regioni.

[n,m]=size(X);
grafo=zeros(n-1,3);


if n>1
    
    %ordina i vettori
    X=sortrows([X,index],cut+1);
    index=X(:,m+1);
    X=X(:,1:m);
    
    
    %aggiorna cut per le chiamate successive 
    cut=rem(cut+1,m);
    
    %calcola uno spanning tree per le due met
    
    grafo(1:floor(n/2)-1,:)=MSTdivideetimperasort(X(1:floor(n/2),:),cut,index(1:floor(n/2),:) );
    grafo(floor(n/2):n-2,:)=MSTdivideetimperasort(X(floor(n/2)+1:n,:),cut,index(floor(n/2)+1:n,:) );
    
    
    %sceglie l'arco che collega le due met a partire dai 2*nodeunion vettori con la
    %coordinata cut+1 pi vicina 
    
    nodeunion=max(floor(sqrt(n)/m),1);
    v=vecnorm((X((floor(n/2)-nodeunion+1):floor(n/2),:)-ones(nodeunion,1)*X(floor(n/2)+1,:)),2,2);
    [wmin,ind]=min(v);
    k=floor(n/2)+1;
    j=ind+floor(n/2)-nodeunion;
    
    for s=1:nodeunion-1
        [w,ind]=min(vecnorm((X( (floor(n/2)-nodeunion+1):floor(n/2) ,:)-ones(nodeunion,1)*X(floor(n/2)+1+s,:)),2,2));
        
        if w<wmin
            wmin=w;
            k=floor(n/2)+1+s;
            j=ind+floor(n/2)-nodeunion;
        end
    end
    
    grafo(n-1,:)=[(index(j)), (index(k)),wmin];

end

end
