%test che calcola e traccia un grafico di:
%peso dello spanning tree e tempo necessario al calcolo
%per grafi euclidei in Rn generati in modo aleatorio
%e con numero di nodi uguale a 2000*1, 2000*2, 2000*3, ..., 100000
%e confronta i risultati nel caso si usi l'euristica MSTeuh,
%MSTeuhbar e MSTeusort.

%numero massimo di nodi (x2000)
n=50;

%numero di test per ogni numero di nodi
r=5;
%dimensione dello spazio in cui sono contenuti i nodi
m=2;

peso_geneusort=zeros(n,1);
peso_geneuh=zeros(n,1);
peso_geneuhbar=zeros(n,1);



avtimeeuh=zeros(n,1);
avtimeeuhbar=zeros(n,1);
avtimeeusort=zeros(n,1);

for k=n:-1:1
    
    pesoeusort=zeros(r,1);
    pesoeuh=zeros(r,1);
    pesoeuhbar=zeros(r,1);
    
    
    timeeuh=zeros(r,1);
    timeeuhbar=zeros(r,1);
    timeeusort=zeros(r,1);
    
    
    for s=1:r
        v=random('Uniform', 0, 1,[2000*k,m]);
        
        tic
        T=MSTeuh(v);
        timeeuh(s)=toc;
        
        T_w=sum(T.Edges.Weight);
        
        pesoeuh(s)=T_w;
        
        tic
        T=MSTeuhbar(v);
        timeeuhbar(s)=toc;
        
        T_w=sum(T.Edges.Weight);
        
        pesoeuhbar(s)=T_w;
        
        tic
        T=MSTeusort(v);
        timeeusort(s)=toc;
        
        T_w=sum(T.Edges.Weight);
        
        pesoeusort(s)=T_w;
    end
    
    
    avtimeeuh(k)=mean(timeeuh);
    avtimeeuhbar(k)=mean(timeeuhbar);
    avtimeeusort(k)=mean(timeeusort);
    
    peso_geneuh(k)=mean(pesoeuh);
    peso_geneuhbar(k)=mean(pesoeuhbar);
    peso_geneusort(k)=mean(pesoeusort);
    
end

t=1:n;
t=2000*t;

figure (1)
plot(t,peso_geneuh)
hold on

plot(t,peso_geneuhbar)
plot(t,peso_geneusort)

legend('euh', 'euhbar','eusort', 'Location', 'best')
xlabel('numero nodi ')
ylabel('peso del MST')
hold off

figure (2)

plot(t,avtimeeuh)
hold on
plot(t,avtimeeuhbar)
hold on
plot(t,avtimeeusort)
legend( "euh","euhbar", "eusort", 'Location', 'best')
xlabel('numero nodi')
ylabel('tempi')
hold off
